<template>
  <div>
    <div class="row">
      <div class="col-xs-12">
        <p class="add-subscription-title">Выберите направления “Откуда/Куда”, перевозки по которым вас интересуют</p>
      </div>
    </div>

    <div class="row">
      <div class="col-xs-12">
        <ob-radio
          v-for="direction in directions"
          :key="direction.value"
          :label="direction.title"
          v-model="selectDirection"
          :valueInput="direction.value"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-select
          label="Откуда"
          placeholder="Выберите одну или несколько точек"
          required
          :value="fromLocationsValue"
          :items="locations"
          :is-dropdown="true"
          :isAutoComplete="true"
          data-qa="selectedFrom"
          display-exp="russianName"
          :class="{ isAll: isFromAll }"
          @input="input($event, 'from')"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-select
          label="Куда"
          placeholder="Выберите одну или несколько точек"
          required
          :value="toLocationsValue"
          :items="locations"
          :is-dropdown="true"
          :class="{ isAll: isToAll }"
          :isAutoComplete="true"
          data-qa="selectedTo"
          display-exp="russianName"
          @input="input($event, 'to')"
        />
      </div>
    </div>
  </div>
</template>

<script>
  import ObRadio from 'common-components/src/obComponents/obRadio';
  import ObSelect from 'common-components/src/obComponents/obSelect';
  import { mapGetters } from 'vuex';
  export default {
    name: 'SubscriptionModalLocationsFromTo',
    components: {
      ObRadio,
      ObSelect
    },
    props: {
      fromLocations: {
        type: Object,
        required: true
      },
      toLocations: {
        type: Object,
        required: true
      },
      type: {
        type: String,
        required: true
      }
    },
    data () {
      return {
        isFromAll: false,
        isToAll: false,
        locations:[],
        directions: [
          {
            title: 'Туда/обратно',
            value: 'FROM_TO_BACKWARD'
          },
          {
            title: 'Только одном направлении',
            value: 'FROM_TO'
          }
        ]
      };
    },
    mounted() {
      this.locations = this.listLocations.map(key => key)
      this.locations.unshift({ 'russianName': 'Все опорники', 'uuid': 'all' })
    },
    computed: {
      ...mapGetters({
        listLocations: 'subscriptions/listLocations'
      }),
      fromLocationsValue() {
        const locationUuids = this.locations.map(location => location.uuid)
        if (this.fromLocations.isAll) return locationUuids
        return this.fromLocations.fromLocationUuids
      },
      toLocationsValue() {
        const locationUuids = this.locations.map(location => location.uuid)
        if (this.toLocations.isAll) return locationUuids
        return this.toLocations.toLocationUuids
      },
      selectDirection: {
        get() {
          return this.type
        },
        set(data) {
          this.$emit('setType', data)
        }
      }
    },
    methods: {
      input (event, direction) {
        const isAdd = this[`${direction}LocationsValue`].length < event.length
        const isAllSelected = isAdd && (event.includes('all') || event.length === this.listLocations.length)
        const isAllVar = direction === 'to' ? 'isToAll' : 'isFromAll'
        let locations = []

        if (isAllSelected) {
          locations = []
          this[isAllVar] = true
        } else if (event.includes('all')) {
          locations = event.filter(locationUuid => locationUuid !== 'all')
          this[isAllVar] = false
        } else {
          if (event.length === this.listLocations.length) {
            locations = []
          } else {
            locations = event
          }
          this[isAllVar] = false
        }

        this.$emit('setLocations', locations, direction, this[isAllVar])
      },
    }
  };
</script>
<style lang="scss" scoped>
::v-deep {
  .isAll {
    .ob-selector__multi-select {
      &-item {
        &:first-child {
          display: none !important;
        }
      }
    }
  }
}
</style>